Attribute VB_Name = "Module1"
Public que_poner As Boolean, nivel As Integer
' Declarations used to force the window to stay on top of the other windows.
Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, _
                                            ByVal hWndInsertAfter As Long, _
                                            ByVal X As Long, _
                                            ByVal Y As Long, _
                                            ByVal cx As Long, _
                                            ByVal cy As Long, _
                                            ByVal wFlags As Long) As Long

Public Const HWND_TOPMOST = -1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1



Sub main()
Dim objApp As SolidEdgeFramework.Application, objModelo As AssemblyDocument
Dim i As Integer, j As Integer, n As Integer

    On Error Resume Next
    Set objApp = GetObject(, "SolidEdge.Application")
    If Err Then
        Err.Clear
        MsgBox "Esta utilidad debe ejecutarse en Solid Edge Conjunto"
        End
    End If
    On Error GoTo 0
    If objApp.ActiveDocumentType <> igAssemblyDocument Then
        MsgBox "Esta utilidad debe ejecutarse en Solid Edge Conjunto"
        End
    End If
    Set objModelo = objApp.ActiveDocument
    objApp.DelayCompute = True
    Load Form1
    Form1.Show
    WindowToTop Form1.hWnd
    'Saber qu hay que poner:
    '(segun lo que se lea de las propiedades de la pieza)
    '                         que_poner=true -> poner nombres.
    '                         que_poner=false -> poner descripciones
    que_poner = NombreoDescripcion(objModelo)
    
    'Procesar el conjunto
    nivel = 1
    Call muestraEstructura(objModelo, nivel)
    Unload Form1
    objApp.DelayCompute = False
    Set objModelo = Nothing
    Set objApp = Nothing
    End

End Sub

Private Sub muestraEstructura(Document As Object, nivel As Integer)
Dim nombrepieza_ant As String, nombrefich_ant As String
Dim nombrefich_act As String
Dim i As Integer, n As Integer, j As Integer
Dim objLinkedDocs As solidedgeassembly.Occurrences
    If nivel = 1 Then
        Set objLinkedDocs = Document.Occurrences
    Else
        Set objLinkedDocs = Document.OccurrenceDocument.Occurrences
    End If
    With objLinkedDocs
        If .Count > 0 Then
            'Ahora proceso el conjunto a este nivel
            'Rellenamos la primera pieza.
            'A partir de la siguiente se compara con las anteriores para llevar el numero
            'de piezas del conjunto.
            
            'Relleno las siguientes. Comparo con las anteriores
            n = 1 'Si no encuentra otra pieza el numero detras de los dos puntos es "1"
            'Buscamos el ultimo numero (n) de ocurrencia y le sumamos 1 (si es que hay)
            Form1.pb1.Min = 0
            Form1.pb1.Max = .Count
            For i = 1 To .Count
                Form1.pb1.Max = .Count
                nombrefich_act = .Item(i).OccurrenceFileName
                'Mostrar progreso en el formulario
                Form1.pb1.Value = i
                Form1.Label1.Caption = "Procesando: " & nombrefich_act
                Form1.Refresh
                'Comparar con los demas. Obtener n
                For j = i - 1 To 1 Step -1
                    nombrepieza_ant = .Item(j).Name
                    nombrefich_ant = .Item(j).OccurrenceFileName
                    If LCase(nombrefich_act) = LCase(nombrefich_ant) Then
                    'Es la misma pieza: Busco el numero del anterior y sumo 1
                    ' y lo escribo en el nombre de esta.
                        n = CInt(Mid(nombrepieza_ant, InStr(nombrepieza_ant, ":") + 1)) + 1
                        Exit For
                    End If
                Next j
                
                'Pongo el nombre de la pieza
                Call cambiarnombre(.Item(i), n, que_poner)

                If UCase(Right(.Item(i).OccurrenceFileName, 3)) = "ASM" Then
                    Call muestraEstructura(.Item(i), nivel + 1)
                End If
            Next i
        End If
    End With
End Sub

'-----------------------------------------------
'Cambiarnombre: Pone o nombre o descripcion, segun el valor de poner_nombre
'Poner nombre=true -> Nombre
'Poner nombre=false -> descripcion
'-----------------------------------------------
Sub cambiarnombre(documento As Occurrence, ndoc As Integer, poner_nombre As Boolean)
    With documento
        If poner_nombre Then
            .Name = nombrefich(.OccurrenceFileName) & ":" & ndoc
        Else
            If Trim(.OccurrenceDocument.SummaryInfo.Title) = "" Then
                .Name = "*** " & nombrefich(.OccurrenceFileName) & ":" & ndoc
            Else
                .Name = .OccurrenceDocument.SummaryInfo.Title & ":" & ndoc
            End If
        End If
    End With
End Sub

'------------------------------
'nombreodescripcion: decide que poner segun lo que haya en una propiedad custom
'llamada nombredescripcion.
'"1" = "Nombre
'"0"=Descripcion
'Devuelve un boolean que se usa en otras funciones:
'si es true=nombre
'si es false=descripcion
'--------------------------------
Function NombreoDescripcion(objModelo As AssemblyDocument) As Boolean
Dim nod As String
    On Error Resume Next
    'Leer propiedad nombreodescripcion de custom
    'Si no existe se crea y se pone a verdadero (nombre)
    nod = objModelo.Properties.Item("Custom").Item("nombreodescripcion").Value
    If Err Then
        objModelo.Properties.Item("Custom").Add "nombreodescripcion", "0"
        nod = "0"
    End If
    'Ahora cambio lo que he leido al contrario y lo guardo en las propiedades para la proxima vez
    If nod = "1" Then
        nod = "0"
    Else
        nod = "1"
    End If
    objModelo.Properties.Item("Custom").Item("nombreodescripcion").Value = nod
    objModelo.Properties.Save
    'Devuelvo verdadero si es "1" y falso si es "0"
    NombreoDescripcion = (nod = "1")
End Function

'------------------------------------------------------------------
'nombrefich: Obtiene el nombre de fichero limpio a partir del path completo
'------------------------------------------------------------------
Function nombrefich(pathcompleto As String) As String
Dim aux As String
    nombrefich = Mid(pathcompleto, ultimocaracter(pathcompleto, "\") + 1)
End Function


'------------------------------------------------------------------
' ultimocaracter: Devuelve un integer con la posicion de la ultima aparicion
' del caracter buscado en un string o 0 si no esta
'------------------------------------------------------------------
Function ultimocaracter(texto As String, caracter As String) As Integer
Dim i As Integer
    ultimocaracter = 0
    For i = 1 To Len(texto)
        If Mid(texto, i, 1) = caracter Then
            ultimocaracter = i
        End If
    Next i
End Function

' Forces a window to the top and keeps it on top.
Public Sub WindowToTop(hWnd As Long)
    Call SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
End Sub



